#ifdef GL_ES
precision mediump float;
#endif

#define INTENSITY 10.5 //6.5
#define GLOW 2.0

float  iGlobalTime = CC_Time[0];           // shader playback time (in seconds)

uniform vec2 resolution;

vec2  iResolution = resolution;           // viewport resolution (in pixels)
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;



vec3 blob(vec2 uv, vec3 color, vec2 speed, vec2 size, float time) {
	vec2 point = vec2(
		sin(speed.x * time) * size.x,
		cos(speed.y * time) * size.y
	);

	float d = 1.0 / distance(uv, point);
	d = pow(d / INTENSITY, GLOW);
	
	return vec3(color.r * d, color.g * d, color.b * d);
}

void main() {
	vec2 uv = -1.0 + 2.0 * (v_texCoord.xy / iResolution.xy);

	float time = iGlobalTime * 0.75;

	//float freqBlue = texture2D(CC_Texture0, vec2(0.01,0.25)).x * 4.0;
	//float freqGreen = texture2D(CC_Texture0, vec2(0.1,0.25)).x * 2.0;
	
	float freqBlue = texture2D(CC_Texture0, v_texCoord.xy / iResolution.xy).x * 4.0;
	float freqGreen = texture2D(CC_Texture0, v_texCoord.xy / iResolution.xy).x * 2.0;

	vec4 color = vec4(0.0, 0.0, 0.0, 1.0);
	color.rgb += blob(uv, vec3(1.0, 0.3 * freqGreen, 0.5 * freqBlue), vec2(1.7, 2.2), vec2(0.4, 0.1), time);
	color.rgb += blob(uv, vec3(1.0, 0.3 * freqGreen, 0.5 * freqBlue), vec2(1.2, 2.3), vec2(0.3, 0.2), time);
	color.rgb += blob(uv, vec3(1.0, 0.3 * freqGreen, 0.5 * freqBlue), vec2(2.3, 2.1), vec2(0.2, 0.3), time);
	color.rgb += blob(uv, vec3(1.0, 0.3 * freqGreen, 0.5 * freqBlue), vec2(2.1, 1.0), vec2(0.1, 0.4), time);

	gl_FragColor = color;
}