/* texture.frag - texture lookup example */

//
// This defines a sampler.
// To use textures, load an image into a texture unit and
// assign the texture unit index to the sampler.
//

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;

vec4 blur()
{
	vec2 p = v_texCoord.xy;
	vec2 pix_size = p / resolution.xy;
	
	vec4 sample = vec4(0, 0, 0, 0);
	
	//combine pixels around it using offset&weight samping 9 pixels
	sample += texture2D(CC_Texture0, v_texCoord + 4 * pix_size) * 0.05;
	sample += texture2D(CC_Texture0, v_texCoord + 3 * pix_size) * 0.09;
	sample += texture2D(CC_Texture0, v_texCoord + 2 * pix_size) * 0.12;
	sample += texture2D(CC_Texture0, v_texCoord + 1 * pix_size) * 0.15;
	sample += texture2D(CC_Texture0, v_texCoord + 0 * pix_size) * 0.16;
	sample += texture2D(CC_Texture0, v_texCoord - 1 * pix_size) * 0.15;
	sample += texture2D(CC_Texture0, v_texCoord - 2 * pix_size) * 0.12;
	sample += texture2D(CC_Texture0, v_texCoord - 3 * pix_size) * 0.09;
	sample += texture2D(CC_Texture0, v_texCoord - 4 * pix_size) * 0.05;

	return sample;
}

//
// entry point
//
void main( void )
{
	gl_FragColor = blur();
	//gl_FragColor *= blur();
	//gl_FragColor = texture2D( textureImage, v_texCoord );
}
