#ifdef GL_ES
precision mediump float;
#endif

vec3 GlowColor = vec3(0.2126, 0.7152, 0.0722);//发光色
float GlowRange = 1;//发光范围
float GlowExpand = 3; //发光强度

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;

float  iGlobalTime = CC_Time[1]; 

vec2  iResolution = resolution;  

vec4 lerp(vec4 a, vec4 b, vec4 f)
{
    return (1 - f) * a + b * f;
}
mat2 rotate2d(float angle){
    return mat2(cos(angle),-sin(angle),
                sin(angle),cos(angle));
}

float variation(vec2 v1, vec2 v2, float strength, float speed) {
    return sin(
        dot(normalize(v1), normalize(v2)) * strength + iGlobalTime * speed
    ) / 100.0;
}

vec3 paintCircle (vec2 uv, vec2 center, float rad, float width) {
    
    vec2 diff = center-uv;
    float len = length(diff);

    len += variation(diff, vec2(0.0, 1.0), 5.0, 2.0);
    len -= variation(diff, vec2(1.0, 0.0), 5.0, 2.0);
    
    float circle = smoothstep(rad-width, rad, len) - smoothstep(rad, rad+width, len);
    return vec3(circle);
}


void main()
{
    vec2 uv = v_texCoord.xy / iResolution.xy;
    uv.x *= 1.5;
    uv.x -= 0.25;
    
     
    //paint color circle
    vec3 color = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
    
    //color with gradient
    vec2 v = rotate2d(iGlobalTime) * uv;
    color *= vec3(v.x, v.y, 0.7-v.y*v.x);
    
    //paint white circle
    //color += paintCircle(uv, center, radius, 0.01);
    //vec4 originColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
    
    gl_FragColor = vec4(color, 1.0);
}
