#define GLOW 1.0 

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;

#define GLOW 1.0

vec4 lerp(vec4 a, vec4 b, float f)
{
    return (1 - f) * a + b * f;
}

float dSphere(vec2 pCenter, float pRayon, vec2 fragCoord)
{
    return length(fragCoord.xy - pCenter) - pRayon;
}

vec3 sGlow(vec3 pColor, float ld)
{
    return pColor * exp(-(ld/25.0)*0.5) * GLOW;
}

void main()
{
    float ld2 = dSphere(vec2(resolution.xy*0.5), 50.0,v_texCoord);
    vec3 lColor = sGlow(vec3(1.0, 1.0, 0.0), ld2);
    vec4 originCol = texture2D(CC_Texture0, v_texCoord);

   // gl_FragColor = lerp(vec4(lColor, 1), originCol, 0.5);
   gl_FragColor = vec4(lColor, 1);
}